---
# -- required vars
- name  : '{{ role_namespace }}.check.required.vars'
  assert:
    that:
      - (vars[item] is defined)
    msg: 'VARIABLE [{{ item }}] has to be defined for this host'
  with_items: '{{ role_required_vars }}'

# update role namespace
- name: 'role.namespace.update'
  set_fact:
    role_namespace: '{{ role_shortname }}.{{ run_mode|upper }}'


# PRETASKS
# ========

# debug sys type
- name: '{{ role_namespace }}.debug.sys.type'
  debug:
    msg: '{{ run_mode|upper }} {{ role_shortname }} PROFILE on [{{ sys_os_family }}] system'

# load var file according to sys_os_family
- name: '{{ role_namespace }}.load.{{ sys_os_family }}.vars'
  include_vars: '{{ sys_os_family }}.yml'


# COMMON TASKS
# ============

# wait for package manager to be available
- name: '{{ role_namespace }}.common.check.for.{{ ansible_pkg_mgr }}.processes'
  register: checkPkgManager
  command: 'pgrep -a {{ ansible_pkg_mgr }}'
  changed_when: False
  failed_when: False
  until: (checkPkgManager.rc > 0)
  retries: 120
  delay: 5


# use legacy ansible_python_interpreter for RHEL7 hosts
- name: '{{ role_namespace }}.use.legacy.ansible_python_interpreter'
  set_fact:
    ansible_python_interpreter: '/usr/bin/python'
  when:
    - (sys_os_family in ["redhat"])
    - (ansible_distribution_major_version|int < 8)


# install os packages
- name: '{{ role_namespace }}.common.install.sys_os_packages'
  package:
    name: '{{ sys_os_packages }}'
  retries: 4
  delay: 15



# OS SPECIFIC TASKS
# =================

# load main task file according to sys_os_family
- name: '{{ role_namespace }}.load.{{ sys_os_family }}.tasks'
  include_tasks: 'main.{{ sys_os_family }}.yml'


# eof
